import numpy as np

t = 100.0 # t/U
a = 1.0 # lattice parameter

N = 40.0 # lattice points in each direction

alpha = 1.0 # U_updown / U

mu_A = 0.9 # assuming mu_A = mu_B 
mu_B=mu_A


E_A=E_B=F_A=F_B=F=eps=R=K=H=M= 0

deltak = 2.0*np.pi/(a*N)                        # Delta k
kx = np.arange(-np.pi/a, np.pi/a, deltak)
ky = np.arange(-np.pi/a, np.pi/a, deltak)
kx = np.delete(kx,np.argwhere(kx==0))
ky = np.delete(ky,np.argwhere(ky==0))



def main():
    
    # Two branches in case 1:
    Energy11 = 0
    Energy12 = 0
    print('test')
    

    F_A = mu_A
    F_B = F_A
    F = F_A
    eps = 4.0*t*(np.sin(kx*a/2)**2 + np.sin(ky*a/2)**2)
    F_AB = np.sqrt(mu_A*mu_B)*alpha
    M = (eps*(eps+2.0*F_A)-eps*(eps+2.0*F_B))**2+16.0*F_AB*eps**2
    #L = eps*(eps+2.0*F_A)/2.0 + eps*(eps+2.0*F_B)/2.0

    Energy11 = np.sqrt(eps*(eps+2*F_A)/2 + eps*(eps+2*F_B)/2 + np.sqrt(M)/2)

    Energy12 = np.sqrt(eps*(eps+2*F_A)/2 + eps*(eps+2*F_B)/2 - np.sqrt(M)/2)
    
    Energy1 = np.sum(Energy11 + Energy12)/2.0       # Perform sum over all k


    # Two branches in case 2:
    Energy21 = 0
    Energy22 = 0
    
    E_A = eps + F_A
    E_B = eps + F_B
    R = (E_A-E_B)**2*(E_A+E_B+2.0*F_AB)*(E_A+E_B-2.0*F_AB)
    K = E_A**2+E_B**2 - F**2 - F_AB**2
    
    Energy21 = np.sqrt(2.0*(K+np.sqrt(R)) + 2.0*abs(F**2 - F_AB**2))
    Energy22 = np.sqrt(2.0*(K-np.sqrt(R)) + 2.0*abs(F**2 - F_AB**2))

    Energy2 = np.sum(Energy21 + Energy22)/4.0       # Perform sum over all k
    

    print('\n')
    print('N = %i' % N)
    
    print('Difference in percentage:')
    print(100*(Energy2-Energy1)/Energy1)
    
    

    
            
            
    

if __name__=="__main__":
   main()
